
-- Defining Options

local options = { 
    type='group',
    args = {
	debug = {
            type = 'toggle',
            name = 'debug',
            desc = 'Toggles debug mode',
            get = "IsDebug",	
            set = "ToggleDebug",
        },
	config = {
		type = 'toggle',
		name = 'config',
		desc = 'Toggles config mode',
		get = "IsConfig",
		set = "ToggleConfig",
	},
    },
}



-- Calling libraries and instancing them
Darkness = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0")
Darkness:RegisterChatCommand("/Darkness", "/dark", options)
local lego1 = LibStub("LegoBlock-Beta1"):New("SpellToCastFirst" ,"Block1", nil, {})
local lego2 = LibStub("LegoBlock-Beta1"):New("SpellToCastSecond" ,"Block2", nil, {})

-- TimeBlock = DongleStub("Dongle-1.0"):New("Darkness")
-- DarknessLegos = DongleStub("Dongle-1.0"):New("Legos", {})
-- local legoblocks = {}

-- Setting default values to variables
Darkness:RegisterDB("DarknessDB", "DarknessDBPC")
Darkness:RegisterDefaults("profile", {
	debug = false,
	config = false,
	lego1 = {
		width = 128,
		height = 32,
		showText = true,
		showIcon = true,
		scale = 1,
		group = nil,
		x = 64,
	},
	lego2 = {
		width = 128,
		height = 32,
		showText = true,
		showIcon = true,
		scale = 1,
		group = nil,
		x = 64,
	},
} )

-- Setting default values to local variables
local vampiricTouchIcon = "Spell_Holy_Stoicism"
local vampiricTouchText = "Vampiric Touch"
-- local vampiricTouchText = "VT"
local shadowWordPainIcon = "Spell_Shadow_ShadowWordPain"
local shadowWordPainText = "Shadow Word: Pain"
-- local shadowWordPainText = "SW:P"
local vampiricEmbraceIcon = "Spell_Shadow_UnsummonBuilding"
local vampiricEmbraceText = "Vampiric Embrace"
local shadowWordDeathText = "Shadow Word: Death"
-- local shadowWordDeathText = "SW:D"
local shadowWordDeathIcon = "Spell_Shadow_DemonicFortitude"
local mindBlastText = "Mind Blast"
-- local mindBlastText = "MB"
local mindBlastIcon = "Spell_Shadow_UnholyFrenzy"
local mindFlayText = "Mind Flay"
-- local mindFlayText = "MF"
local mindFlayIcon = "Spell_Shadow_SiphonMana"
local minimumCooldown = 1.5
local spellCast, spellCast2, spellCast3
local label

local textureTable = {
	"Vampiric Touch", "Spell_Holy_Stoicism",
	"Shadow Word: Pain", "Spell_Shadow_ShadowWordPain",
	"Vampiric Embrace", "Spell_Shadow_UnsummonBuilding",
	"Shadow Word: Death", "Spell_Shadow_DemonicFortitude",
	"Mind Blast", "Spell_Shadow_UnholyFrenzy",
	"Mind Flay", "Spell_Shadow_SiphonMana"
}
	
	


--The rest
function Darkness:OnInitialize()
    -- Called when the addon is loaded
end

function Darkness:OnEnable()
    -- Called when the addon is enabled
    -- self:Print("MW: OnEnable")
	if select(2, UnitClass("player")) == "PRIEST" then
    		-- self:Print("Correct PowerType detected")
	    

		self:RegisterEvent("PLAYER_REGEN_ENABLED", "OnCombatExit")
		self:RegisterEvent("PLAYER_REGEN_DISABLED", "OnCombatEnter")
	
	        --self:New( "HelloWorld"[, "My first lego block", nil, {}] )
	        lego1:SetDB(self.db.profile.lego1)
	        lego2:SetDB(self.db.profile.lego2)
	        lego1:SetText("Boks1")
	        lego2:SetText("Boks2")
	end    
        --[[lego1:ShowText()
        lego2:ShowText()
        lego1:ShowIcon()
        lego2:ShowIcon()--]]
end



function Darkness:OnDisable()
    -- Called when the addon is disabled
    self:CancelAllScheduledEvents()
    self:UnregisterAllEvents()
end

function Darkness:OnCombatExit()
	self.isInCombat = 0
	lego1:SetText("")
	lego2:SetText("")
	self:UnregisterEvent("UNIT_SPELLCAST_SENT")
end

function Darkness:OnCombatEnter()
	self.isInCombat = 1
	
	self:DebugPrint("Entering combat")
	self:RegisterEvent("UNIT_SPELLCAST_SENT", "OnSpellcast")
	self:RegisterEvent("PLAYER_TARGET_CHANGED", "OnTargetChanged")	
	
end

function Darkness:FormEvent(label)
    self:Print("FormEvent() called")
    label:SetText("test")
end

function Darkness:OnLoad()
    
end



function Darkness:OnSpellcast(unit, spell, rank, target)
	--if spell == mindFlayText or spell == shadowWordDeathText or spell == mindBlastText or spell == shadowWordPainText or spell == vampiricEmbraceText or spell == vampiricTouchText then
	if UnitIsEnemy("player", "target") then
	local spellToCastFirst, spellToCastSecond, duration, spellToCastFirstIcon, spellToCastSecondIcon
		
		spellCast3 = spellCast2
		spellCast2 = spellCast
		
		spellToCastFirst = self:FindSpellToCast(spell, spellCast2, spellCast3, 1, 1)
		
		spellCast3 = spellCast2
		spellCast2 = spell
		spellToCastSecond = self:FindSpellToCast(spellToCastFirst, spellCast2, spellCast3, 2, 1)
		if spell ~= nil then
			self:DebugPrint("(" .. spell .. ") -> ".. spellToCastFirst .. " -> " .. spellToCastSecond)
		else
			self:DebugPrint("( Target Changed ) -> " .. spellToCastFirst .. " -> " .. spellToCastSecond)
		end
	
         lego1:SetText(spellToCastFirst)
         lego2:SetText(spellToCastSecond)
    
	 lego1:SetIcon("Interface\\Icons\\" .. self:SetIcon (spellToCastFirst))

         lego2:SetIcon("Interface\\Icons\\" .. self:SetIcon (spellToCastSecond))

         
         
	end	
	
end

function Darkness:SetIcon(spellName)
	local spellIcon
	if spellName == vampiricTouchText then
		spellIcon = vampiricTouchIcon
	elseif spellName == shadowWordPainText then
		spellIcon = shadowWordPainIcon
	elseif spellName == vampiricEmbraceText then
		spellIcon = vampiricEmbraceIcon
	elseif spellName == shadowWordDeathText then
		spellIcon = shadowWordDeathIcon
	elseif spellName == mindBlastText then
		spellIcon = mindBlastIcon
	elseif spellName == mindFlayText then
		spellIcon = mindFlayIcon
	end
	return spellIcon
end
	

function Darkness:OnTargetChanged()
	spellCast = nil
	spellCast2 = nil
	spellCast3 = nil
	self:OnSpellcast(_,_,_,"target")
end



function Darkness:FindSpellToCast(lastCastSpell, previousCastSpell, spellCast3rd, seq, veEnabled)

	-- self:DebugPrint("FTC() - lCS " .. lastCastSpell .. " seq: " .. seq .. " veEnabled: " .. veEnabled)
		local spellToCast = ""
		if lastCastSpell == mindFlayText then
			seq = seq+1
		end
		
		local timeLeft = self:FindADebuff("target", vampiricTouchIcon)
		
		if  spellCast3rd ~= vampiricTouchText 
			and previousCastSpell ~= vampiricTouchText 
			and lastCastSpell ~=vampiricTouchText 
			and (timeLeft == nil or timeLeft < (seq+1)*minimumCooldown) 
			
			then
			spellToCast = vampiricTouchText
		else
			timeLeft = self:FindADebuff("target", shadowWordPainIcon)
			if  spellCast3rd ~= shadowWordPainText 
				and previousCastSpell ~= shadowWordPainText 
				and lastCastSpell ~= shadowWordPainText 
				and (timeLeft == nil or timeLeft < seq*minimumCooldown) 
				
				then
				spellToCast = shadowWordPainText
			
			else 
				veCD = 0
				if veEnabled == 1 then 
					timeLeft = self:FindADebuff("target", vampiricEmbraceIcon)
					veCD = 0
					-- local startTime, duration,_ = GetSpellCooldown(vampiricEmbraceText)
					local startTime, duration,_ = GetSpellCooldown("Vampiric Embrace")
										
					if duration ~= 0 then
						veCD = startTime+duration - GetTime()
					end
				end
			
				if  veEnabled == 1 
					and spellCast3rd ~= vampiricEmbraceText 
					and previousCastSpell ~= vampiricEmbraceText 
					and lastCastSpell ~= vampiricEmbraceText 
					and (timeLeft == nil or timeLeft < seq*minimumCooldown) 
					and veCD < seq*minimumCooldown 
				
					then
					spellToCast = vampiricEmbraceText
					
			
				else
				
					timeLeft = 0;
					duration = 0;
					local startTime, duration,_ = GetSpellCooldown(mindBlastText)
					-- local startTime, duration,_ = GetSpellCooldown("Mind Blast")
					
					if duration ~= 0 then
						timeLeft = startTime+duration - GetTime() --GetTime() - duration - startTime
						-- timeLeft = GetTime() - duration - startTime
						
					end
					
					-- _,timeLeft,_ = GetSpellCooldown(mindBlastText)
					
					self:DebugPrint("Mind Blast CD: " .. timeLeft)
					if  spellCast3rd ~= mindBlastText 
						and previousCastSpell ~= mindBlastText 
						and lastCastSpell ~= mindBlastText 
						and timeLeft < seq*minimumCooldown
						
						then
						spellToCast = mindBlastText
						
					else
						-- _,timeLeft = GetSpellCooldown(shadowWordDeathText)
						timeLeft = 0;
						-- local startTime, duration = GetSpellCooldown("Shadow Word: Death")
						local startTime, duration = GetSpellCooldown(shadowWordDeathText)
										
						if duration ~= 0 then
							timeLeft = startTime+duration - GetTime() --GetTime() - duration - startTime
							
						end
						
						self:DebugPrint("SW:D CD: " .. timeLeft)
						if  spellCast3rd ~= shadowWordDeathText 
							and 
							previousCastSpell ~= shadowWordDeathText 
							and 
							lastCastSpell ~= shadowWordDeathText 
							and 
							timeLeft < seq*minimumCooldown
							
							then
							spellToCast = shadowWordDeathText
							-- self:Print(spellToCast)
	
						else
							spellToCast = mindFlayText
						
						end
					end	
				
				end
	
				
			
			end
		end
	
	return spellToCast
end


--Function to find a debuff cast by the player.
function Darkness:FindADebuff(unit, matchTexture)
		
		-- self:DebugPrint("FindABuff, Unit = " .. unit);
		-- self:DebugPrint("FindABuff, matchTexture = " .. matchTexture);
		
		local debuffIndex = 1
		while 1 do
			local _, _, texture, _, _, duration, timeLeft  =  UnitDebuff(unit, debuffIndex, _);
			
			if texture == nil then
			--	self:DebugPrint("No debuff found on target")
				return timeLeft
			elseif string.match(texture, "Interface\\Icons\\" .. matchTexture) and timeLeft ~= nil then
				return timeLeft
			--else
			--	self:DebugPrint("Debuff found: " .. texture)
			end
			debuffIndex = debuffIndex + 1
		end	
	
end


--[[ Functions relating to bars
function Darkness:TimerBarSetup()
	self:RegisterCandyBarGroup("Darkness")
	self:RegisterCandyBar("MIND_FLAY", 1, "MindFlayDot",  _, "blue", "green", "blue", "blue")
end--]]

-- Print Functions
function Darkness:DebugPrint(debugString)
	-- self:Print("DebugPrint called")
	if self.db.profile.debug == true then
		self:Print("DEBUG - " .. debugString)
	end
end


function Darkness:PrintStuff(pMessage, pIcon)
	if self.db.profile.showOnParrot then
		Parrot:ShowMessage(pMessage, "Notification", true, 1, 0, 0, "Daville", 22, "Inherit", "Interface\\Icons\\" .. pIcon)
	end
	if self.db.profile.showOnScreen then
		UIErrorsFrame:AddMessage(pMessage, 1.0, 1.0, 1.0, 5.0)
	end
	if self.db.profile.showInChat then
		self:Print(pMessage)
	end
	if self.db.profile.showOnSCT then
		SCT_MSG_FRAME:AddMessage(pMessage, 1, 0, 0, 1)
	end
end




-- Functions for toggling and setting options
function Darkness:IsDebug()
    return self.db.profile.debug
end

function Darkness:ToggleDebug()
    self.db.profile.debug = not self.db.profile.debug
end

function Darkness:ToggleConfig()
	self.db.profile.config = not self.db.profile.config
	if self.db.profile.config then
		self.db.profile.lego1[hidden] = false
		self.db.profile.lego2[hidden] = false
	else 
		self.db.profile.lego1[hidden] = true
		self.db.profile.lego2[hidden] = true
	end
end

function Darkness:IsConfig()
	return self.db.profile.config
end
